module ISet = Set.Make(
  struct 
    type t = int 
    let compare x y = compare x y 
  end);;

type t = ISet.t;;

let empty  = ISet.empty;;
let union  = ISet.union;;
let single = ISet.singleton;;
let elem   = ISet.elements;;
let card   = ISet.cardinal;;
let add    = ISet.add;; 

let add_opt e = function
  | None   -> e
  | Some x -> add x e;;

let collect f l = elem (List.fold_left (fun e x -> add_opt e (f x)) empty l);;