{
open Parser
}

rule token = parse
    [' ' '\t' '\n']                  { token lexbuf }     (* skip blanks *)
  | "tt"                             { TRUE  }
  | "ff"                             { FALSE }
  | ['a'-'z' 'A'-'Z']* ['0'-'9']*    { VAR(Lexing.lexeme lexbuf) }
  | "->"                             { IMP }
  | "&"                              { CONJ  }
  | '|'                              { DISJ  }
  | '('                              { LPAR }
  | ')'                              { RPAR }
  | eof                              { EOF }
