%{
  open Formula
%}

%token <string> VAR
%token IMP DISJ CONJ
%token EOF TRUE FALSE LPAR RPAR
%left  DISJ  
%start main
%type  <Formula.form> main
%%

main:
    formula EOF     { $1 }
;

formula:
    TRUE            { True  }
  | FALSE           { False }
  | VAR             { Atm $1 }
  | formula connector formula { Comp ($2,$1,$3) }
  | LPAR formula RPAR { $2 }
;

connector:
    IMP             { Imp }
  | DISJ            { Disj }
  | CONJ            { Conj }
;
