class type ['a] track =
  object
    method visited : 'a -> bool
    method visit   : 'a -> unit
  end;;

let depthfirst (s:'a track) sons start =
  let rec loop v x =
      if   let b = s#visited x in ( s#visit x; b )
      then v
      else x::(List.fold_left loop v (sons x))
  and notempty = function [] -> false | _ -> true
  in  List.filter notempty (List.map (loop []) start);;
