open Bdd

type 'a column_t = 'a array
type 'a sparse_t = (int*'a) list
type 'a matrix_t = 'a sparse_t array

val scalprod_sl_c   : bdd_t -> (int sparse_t) -> (int column_t) -> int -> int
val prodinc_sm_c    : bdd_t -> (int matrix_t) -> (int column_t) -> (int column_t) -> int
val prod_sm_c       : bdd_t -> (int matrix_t) -> (int column_t) -> (int column_t) -> unit
val addconst_c      : bdd_t -> (int column_t) -> int -> unit
val sparseconv_sc_c : bdd_t -> (int sparse_t) -> (int column_t) -> unit
val matrix_empty    : bdd_t -> int -> int matrix_t
val matrix_id       : bdd_t -> int -> int matrix_t
val sparsesum_r     : bdd_t -> (int sparse_t) -> (int sparse_t) -> (int sparse_t)
val sparsesum_m     : bdd_t -> (int matrix_t) -> (int matrix_t) -> (int matrix_t)